# Generated by Django 2.2 on 2019-12-13 10:28
from django.db import migrations
from arkindex_common.enums import EntityType, MetaType
from enum import Enum


def remove_entity_metatype(apps, schema_editor):
    MetaData = apps.get_model('documents', 'MetaData')
    if not MetaData.objects.exists():
        return

    class OldMetaType(Enum):
        Text = 'text'
        HTML = 'html'
        Date = 'date'
        Location = 'location'
        Reference = 'reference'
        Entity = 'entity'

    # Don't try this at home
    MetaData._meta.fields[2].enum = OldMetaType

    MetaData.objects.filter(type=OldMetaType.Entity, entity__type=EntityType.Location).update(type=OldMetaType.Location)
    MetaData.objects.filter(type=OldMetaType.Entity, entity__type=EntityType.Date).update(type=OldMetaType.Date)
    MetaData.objects.filter(type=OldMetaType.Entity).update(type=OldMetaType.Text)

    # Restore MetaType enum
    MetaData._meta.fields[2].enum = MetaType


def add_entity_metatype(apps, schema_editor):
    MetaData = apps.get_model('documents', 'MetaData')
    if not MetaData.objects.exists():
        return

    class OldMetaType(Enum):
        Entity = 'entity'

    # Don't try this at home
    MetaData._meta.fields[2].enum = OldMetaType
    MetaData.objects.exclude(entity__isnull=True).update(type=OldMetaType.Entity)

    # Restore MetaType enum
    MetaData._meta.fields[2].enum = MetaType


class Migration(migrations.Migration):

    dependencies = [
        ('documents', '0030_rename_classification_best'),
    ]

    operations = [
        migrations.RunPython(remove_entity_metatype, add_entity_metatype),
    ]
