# Generated by Django 2.2 on 2019-10-30 14:33

from django.db import migrations, models

FORWARD_SQL = """
ALTER TABLE images_zone
    ADD COLUMN IF NOT EXISTS polygon_hash VARCHAR(32)
    GENERATED ALWAYS AS (md5(polygon::varchar)) STORED;
CREATE UNIQUE INDEX zone_unique_image_polygon ON images_zone (image_id, polygon_hash);
"""

REVERSE_SQL = """
DROP INDEX IF EXISTS zone_unique_image_polygon;
ALTER TABLE images_zone DROP COLUMN IF EXISTS polygon_hash;
"""


class Migration(migrations.Migration):

    dependencies = [
        ('images', '0011_imageserver_s3_region'),
    ]

    operations = [
        migrations.RunSQL(
            sql=FORWARD_SQL,
            reverse_sql=REVERSE_SQL,
            state_operations=[
                migrations.AddConstraint(
                    model_name='zone',
                    constraint=models.UniqueConstraint(
                        fields=('image', 'polygon'),
                        name='zone_unique_image_polygon',
                    ),
                ),
            ],
        ),
    ]
